# Class Vec2

java.lang.Object
com.codename1.gaming.physics.box2d.common.Vec2

public class Vec2 extends Object
A 2D column vector

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `float`
  `x`
  `float`
  `y`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Vec2()`
  `Vec2(float x, float y)`
  `Vec2(Vec2 toCopy)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final Vec2`
  `abs()`
  Return a new vector that has positive components.
  `static final Vec2`
  `abs(Vec2 a)`
  `final void`
  `absLocal()`
  `static final void`
  `absToOut(Vec2 a, Vec2 out)`
  `final Vec2`
  `add(Vec2 v)`
  Return the sum of this vector and another; does not alter either one.
  `final Vec2`
  `addLocal(float x, float y)`
  Adds values to this vector and returns result - alters this vector.
  `final Vec2`
  `addLocal(Vec2 v)`
  Add another vector to this one and returns result - alters this vector.
  `final Vec2`
  `clone()`
  Return a copy of this vector.
  `static final Vec2`
  `cross(float s, Vec2 a)`
  `static final Vec2`
  `cross(Vec2 a, float s)`
  `static final float`
  `cross(Vec2 a, Vec2 b)`
  `static final void`
  `crossToOut(float s, Vec2 a, Vec2 out)`
  `static final void`
  `crossToOut(Vec2 a, float s, Vec2 out)`
  `static final void`
  `crossToOutUnsafe(float s, Vec2 a, Vec2 out)`
  `static final void`
  `crossToOutUnsafe(Vec2 a, float s, Vec2 out)`
  `static final float`
  `dot(Vec2 a, Vec2 b)`
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `final boolean`
  `isValid()`
  True if the vector represents a pair of valid, non-infinite floating point numbers.
  `final float`
  `length()`
  Return the length of this vector.
  `final float`
  `lengthSquared()`
  Return the squared length of this vector.
  `static final Vec2`
  `max(Vec2 a, Vec2 b)`
  `static final void`
  `maxToOut(Vec2 a, Vec2 b, Vec2 out)`
  `static final Vec2`
  `min(Vec2 a, Vec2 b)`
  `static final void`
  `minToOut(Vec2 a, Vec2 b, Vec2 out)`
  `final Vec2`
  `mul(float a)`
  Return this vector multiplied by a scalar; does not alter this vector.
  `final Vec2`
  `mulLocal(float a)`
  Multiply this vector by a number and return result - alters this vector.
  `final Vec2`
  `negate()`
  Return the negation of this vector; does not alter this vector.
  `final Vec2`
  `negateLocal()`
  Flip the vector and return it - alters this vector.
  `static final void`
  `negateToOut(Vec2 a, Vec2 out)`
  `final float`
  `normalize()`
  Normalize this vector and return the length before normalization.
  `final Vec2`
  `set(float x, float y)`
  Set the vector component-wise.
  `final Vec2`
  `set(Vec2 v)`
  Set this vector to another vector.
  `final void`
  `setZero()`
  Zero out this vector.
  `final Vec2`
  `skew()`
  Get the skew vector such that dot(skew_vec, other) == cross(vec, other)
  `final void`
  `skew(Vec2 out)`
  Get the skew vector such that dot(skew_vec, other) == cross(vec, other)
  `final Vec2`
  `sub(Vec2 v)`
  Return the difference of this vector and another; does not alter either one.
  `final Vec2`
  `subLocal(Vec2 v)`
  Subtract another vector from this one and return result - alters this vector.
  `final String`
  `toString()`
  Returns a string representation of the object.

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### x

    public float x

  - ### y

    public float y

- ## Constructor Details

  - ### Vec2

    public Vec2()

  - ### Vec2

    public Vec2(float x, float y)

  - ### Vec2

    public Vec2(Vec2 toCopy)

- ## Method Details

  - ### setZero

    public final void setZero()
    Zero out this vector.

  - ### set

    public final Vec2 set(float x, float y)
    Set the vector component-wise.

  - ### set

    public final Vec2 set(Vec2 v)
    Set this vector to another vector.

  - ### add

    public final Vec2 add(Vec2 v)
    Return the sum of this vector and another; does not alter either one.

  - ### sub

    public final Vec2 sub(Vec2 v)
    Return the difference of this vector and another; does not alter either one.

  - ### mul

    public final Vec2 mul(float a)
    Return this vector multiplied by a scalar; does not alter this vector.

  - ### negate

    public final Vec2 negate()
    Return the negation of this vector; does not alter this vector.

  - ### negateLocal

    public final Vec2 negateLocal()
    Flip the vector and return it - alters this vector.

  - ### addLocal

    public final Vec2 addLocal(Vec2 v)
    Add another vector to this one and returns result - alters this vector.

  - ### addLocal

    public final Vec2 addLocal(float x, float y)
    Adds values to this vector and returns result - alters this vector.

  - ### subLocal

    public final Vec2 subLocal(Vec2 v)
    Subtract another vector from this one and return result - alters this vector.

  - ### mulLocal

    public final Vec2 mulLocal(float a)
    Multiply this vector by a number and return result - alters this vector.

  - ### skew

    public final Vec2 skew()
    Get the skew vector such that dot(skew_vec, other) == cross(vec, other)

  - ### skew

    public final void skew(Vec2 out)
    Get the skew vector such that dot(skew_vec, other) == cross(vec, other)

  - ### length

    public final float length()
    Return the length of this vector.

  - ### lengthSquared

    public final float lengthSquared()
    Return the squared length of this vector.

  - ### normalize

    public final float normalize()
    Normalize this vector and return the length before normalization. Alters this vector.

  - ### isValid

    public final boolean isValid()
    True if the vector represents a pair of valid, non-infinite floating point numbers.

  - ### abs

    public final Vec2 abs()
    Return a new vector that has positive components.

  - ### absLocal

    public final void absLocal()

  - ### clone

    public final Vec2 clone()
    Return a copy of this vector.
    Overrides:
      `clone` in class `Object`

  - ### toString

    public final String toString()
    Description copied from class: `Object`
    Returns a string representation of the object. In general, the toString method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method. The toString method for class Object returns a string consisting of the name of the class of which the object is an instance, the at-sign character `@', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of: getClass().getName() + '@' + Integer.toHexString(hashCode())
    Overrides:
      `toString` in class `Object`

  - ### abs

    public static final Vec2 abs(Vec2 a)

  - ### absToOut

    public static final void absToOut(Vec2 a, Vec2 out)

  - ### dot

    public static final float dot(Vec2 a, Vec2 b)

  - ### cross

    public static final float cross(Vec2 a, Vec2 b)

  - ### cross

    public static final Vec2 cross(Vec2 a, float s)

  - ### crossToOut

    public static final void crossToOut(Vec2 a, float s, Vec2 out)

  - ### crossToOutUnsafe

    public static final void crossToOutUnsafe(Vec2 a, float s, Vec2 out)

  - ### cross

    public static final Vec2 cross(float s, Vec2 a)

  - ### crossToOut

    public static final void crossToOut(float s, Vec2 a, Vec2 out)

  - ### crossToOutUnsafe

    public static final void crossToOutUnsafe(float s, Vec2 a, Vec2 out)

  - ### negateToOut

    public static final void negateToOut(Vec2 a, Vec2 out)

  - ### min

    public static final Vec2 min(Vec2 a, Vec2 b)

  - ### max

    public static final Vec2 max(Vec2 a, Vec2 b)

  - ### minToOut

    public static final void minToOut(Vec2 a, Vec2 b, Vec2 out)

  - ### maxToOut

    public static final void maxToOut(Vec2 a, Vec2 b, Vec2 out)

  - ### hashCode

    public int hashCode()
    Description copied from class: `Object`
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`
    See Also:
      - `Object.hashCode()`

  - ### equals

    public boolean equals(Object obj)
    Description copied from class: `Object`
    Indicates whether some other object is "equal to" this one. The equals method implements an equivalence relation: It is reflexive: for any reference value x, x.equals(x) should return true. It is symmetric: for any reference values x and y, x.equals(y) should return true if and only if y.equals(x) returns true. It is transitive: for any reference values x, y, and z, if x.equals(y) returns true and y.equals(z) returns true, then x.equals(z) should return true. It is consistent: for any reference values x and y, multiple invocations of x.equals(y) consistently return true or consistently return false, provided no information used in equals comparisons on the object is modified. For any non-null reference value x, x.equals(null) should return false. The equals method for class Object implements the most discriminating possible equivalence relation on objects; that is, for any reference values x and y, this method returns true if and only if x and y refer to the same object (x==y has the value true).
    Overrides:
      `equals` in class `Object`
    See Also:
      - `Object.equals(java.lang.Object)`